constexpr ptr<byte> VramBack = (ptr<byte>)0x1000;
constexpr ptr<byte> VramFront = (ptr<byte>)0x1800;

constexpr byte VramWidth = 24;
constexpr byte VramHeight = 16;
constexpr byte VramStep = 2;
constexpr byte VramWidthW = 32;
constexpr byte VramRowSize = VramWidthW * VramStep;

constexpr byte VramX = (28 - VramWidth) / 2;
constexpr byte VramY = (18 - VramHeight) / 2;
constexpr word OrgOffset = VramY * VramRowSize + VramX * VramStep;
constexpr ptr<byte> VramBackOrg = VramBack + OrgOffset;
constexpr ptr<byte> VramFrontOrg = VramFront + OrgOffset;

constexpr byte WindowWidth = 24;
constexpr byte WindowHeight = 16 - 2;

extern void ClearScreen();
extern word VramOffset(byte x, byte y);
extern ptr<byte> Put(ptr<byte> pVram, byte c);

extern ptr<byte> PrintC(ptr<byte> pVram, byte c);
extern void Put2C(ptr<byte> pVram, byte c);
extern void Put2S(ptr<byte> pVram, ptr<byte> pChars);
extern void Erase2(ptr<byte> pVram);
